Tests: make sure that $DIFF is non-empty
[git/dscho.git] / t / test-lib.sh
blob41fdba1c2dcc9a9d2d0a6c5547ff3076520337d0
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22 # do not redirect again
24 *' --tee '*|*' --va'*)
25 mkdir -p test-results
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
30 exit
32 esac
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 unset VISUAL
46 unset GIT_EDITOR
47 unset AUTHOR_DATE
48 unset AUTHOR_EMAIL
49 unset AUTHOR_NAME
50 unset COMMIT_AUTHOR_EMAIL
51 unset COMMIT_AUTHOR_NAME
52 unset EMAIL
53 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
54 unset GIT_AUTHOR_DATE
55 GIT_AUTHOR_EMAIL=author@example.com
56 GIT_AUTHOR_NAME='A U Thor'
57 unset GIT_COMMITTER_DATE
58 GIT_COMMITTER_EMAIL=committer@example.com
59 GIT_COMMITTER_NAME='C O Mitter'
60 unset GIT_DIFF_OPTS
61 unset GIT_DIR
62 unset GIT_WORK_TREE
63 unset GIT_EXTERNAL_DIFF
64 unset GIT_INDEX_FILE
65 unset GIT_OBJECT_DIRECTORY
66 unset GIT_CEILING_DIRECTORIES
67 unset SHA1_FILE_DIRECTORIES
68 unset SHA1_FILE_DIRECTORY
69 unset GIT_NOTES_REF
70 unset GIT_NOTES_DISPLAY_REF
71 unset GIT_NOTES_REWRITE_REF
72 unset GIT_NOTES_REWRITE_MODE
73 GIT_MERGE_VERBOSITY=5
74 export GIT_MERGE_VERBOSITY
75 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
76 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
77 export EDITOR
79 # Protect ourselves from common misconfiguration to export
80 # CDPATH into the environment
81 unset CDPATH
83 unset GREP_OPTIONS
85 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
86 1|2|true)
87 echo "* warning: Some tests will not work if GIT_TRACE" \
88 "is set as to trace on STDERR ! *"
89 echo "* warning: Please set GIT_TRACE to something" \
90 "other than 1, 2 or true ! *"
92 esac
94 # Convenience
96 # A regexp to match 5 and 40 hexdigits
97 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
98 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
100 # Each test should start with something like this, after copyright notices:
102 # test_description='Description of this test...
103 # This test checks if command xyzzy does the right thing...
105 # . ./test-lib.sh
106 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
107 TERM=$ORIGINAL_TERM &&
108 export TERM &&
109 [ -t 1 ] &&
110 tput bold >/dev/null 2>&1 &&
111 tput setaf 1 >/dev/null 2>&1 &&
112 tput sgr0 >/dev/null 2>&1
113 ) &&
114 color=t
116 while test "$#" -ne 0
118 case "$1" in
119 -d|--d|--de|--deb|--debu|--debug)
120 debug=t; shift ;;
121 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
122 immediate=t; shift ;;
123 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
124 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
125 -h|--h|--he|--hel|--help)
126 help=t; shift ;;
127 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
128 verbose=t; shift ;;
129 -q|--q|--qu|--qui|--quie|--quiet)
130 quiet=t; shift ;;
131 --with-dashes)
132 with_dashes=t; shift ;;
133 --no-color)
134 color=; shift ;;
135 --no-python)
136 # noop now...
137 shift ;;
138 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
139 valgrind=t; verbose=t; shift ;;
140 --tee)
141 shift ;; # was handled already
142 --root=*)
143 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
144 shift ;;
146 echo "error: unknown test option '$1'" >&2; exit 1 ;;
147 esac
148 done
150 if test -n "$color"; then
151 say_color () {
153 TERM=$ORIGINAL_TERM
154 export TERM
155 case "$1" in
156 error) tput bold; tput setaf 1;; # bold red
157 skip) tput bold; tput setaf 2;; # bold green
158 pass) tput setaf 2;; # green
159 info) tput setaf 3;; # brown
160 *) test -n "$quiet" && return;;
161 esac
162 shift
163 printf "%s" "$*"
164 tput sgr0
165 echo
168 else
169 say_color() {
170 test -z "$1" && test -n "$quiet" && return
171 shift
172 echo "$*"
176 error () {
177 say_color error "error: $*"
178 GIT_EXIT_OK=t
179 exit 1
182 say () {
183 say_color info "$*"
186 test "${test_description}" != "" ||
187 error "Test script did not set test_description."
189 if test "$help" = "t"
190 then
191 echo "$test_description"
192 exit 0
195 exec 5>&1
196 if test "$verbose" = "t"
197 then
198 exec 4>&2 3>&1
199 else
200 exec 4>/dev/null 3>/dev/null
203 test_failure=0
204 test_count=0
205 test_fixed=0
206 test_broken=0
207 test_success=0
209 test_external_has_tap=0
211 die () {
212 code=$?
213 if test -n "$GIT_EXIT_OK"
214 then
215 exit $code
216 else
217 echo >&5 "FATAL: Unexpected exit with code $code"
218 exit 1
222 GIT_EXIT_OK=
223 trap 'die' EXIT
225 # The semantics of the editor variables are that of invoking
226 # sh -c "$EDITOR \"$@\"" files ...
228 # If our trash directory contains shell metacharacters, they will be
229 # interpreted if we just set $EDITOR directly, so do a little dance with
230 # environment variables to work around this.
232 # In particular, quoting isn't enough, as the path may contain the same quote
233 # that we're using.
234 test_set_editor () {
235 FAKE_EDITOR="$1"
236 export FAKE_EDITOR
237 EDITOR='"$FAKE_EDITOR"'
238 export EDITOR
241 test_decode_color () {
242 sed -e 's/.\[1m/<WHITE>/g' \
243 -e 's/.\[31m/<RED>/g' \
244 -e 's/.\[32m/<GREEN>/g' \
245 -e 's/.\[33m/<YELLOW>/g' \
246 -e 's/.\[34m/<BLUE>/g' \
247 -e 's/.\[35m/<MAGENTA>/g' \
248 -e 's/.\[36m/<CYAN>/g' \
249 -e 's/.\[m/<RESET>/g'
252 q_to_nul () {
253 perl -pe 'y/Q/\000/'
256 q_to_cr () {
257 tr Q '\015'
260 append_cr () {
261 sed -e 's/$/Q/' | tr Q '\015'
264 remove_cr () {
265 tr '\015' Q | sed -e 's/Q$//'
268 test_tick () {
269 if test -z "${test_tick+set}"
270 then
271 test_tick=1112911993
272 else
273 test_tick=$(($test_tick + 60))
275 GIT_COMMITTER_DATE="$test_tick -0700"
276 GIT_AUTHOR_DATE="$test_tick -0700"
277 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
280 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
282 # This will commit a file with the given contents and the given commit
283 # message. It will also add a tag with <message> as name.
285 # Both <file> and <contents> default to <message>.
287 test_commit () {
288 file=${2:-"$1.t"}
289 echo "${3-$1}" > "$file" &&
290 git add "$file" &&
291 test_tick &&
292 git commit -m "$1" &&
293 git tag "$1"
296 # Call test_merge with the arguments "<message> <commit>", where <commit>
297 # can be a tag pointing to the commit-to-merge.
299 test_merge () {
300 test_tick &&
301 git merge -m "$1" "$2" &&
302 git tag "$1"
305 # This function helps systems where core.filemode=false is set.
306 # Use it instead of plain 'chmod +x' to set or unset the executable bit
307 # of a file in the working directory and add it to the index.
309 test_chmod () {
310 chmod "$@" &&
311 git update-index --add "--chmod=$@"
314 # Use test_set_prereq to tell that a particular prerequisite is available.
315 # The prerequisite can later be checked for in two ways:
317 # - Explicitly using test_have_prereq.
319 # - Implicitly by specifying the prerequisite tag in the calls to
320 # test_expect_{success,failure,code}.
322 # The single parameter is the prerequisite tag (a simple word, in all
323 # capital letters by convention).
325 test_set_prereq () {
326 satisfied="$satisfied$1 "
328 satisfied=" "
330 test_have_prereq () {
331 case $satisfied in
332 *" $1 "*)
333 : yes, have it ;;
335 ! : nope ;;
336 esac
339 # You are not expected to call test_ok_ and test_failure_ directly, use
340 # the text_expect_* functions instead.
342 test_ok_ () {
343 test_success=$(($test_success + 1))
344 say_color "" "ok $test_count - $@"
347 test_failure_ () {
348 test_failure=$(($test_failure + 1))
349 say_color error "not ok - $test_count $1"
350 shift
351 echo "$@" | sed -e 's/^/# /'
352 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
355 test_known_broken_ok_ () {
356 test_fixed=$(($test_fixed+1))
357 say_color "" "ok $test_count - $@ # TODO known breakage"
360 test_known_broken_failure_ () {
361 test_broken=$(($test_broken+1))
362 say_color skip "not ok $test_count - $@ # TODO known breakage"
365 test_debug () {
366 test "$debug" = "" || eval "$1"
369 test_run_ () {
370 test_cleanup=:
371 eval >&3 2>&4 "$1"
372 eval_ret=$?
373 eval >&3 2>&4 "$test_cleanup"
374 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
375 echo ""
377 return 0
380 test_skip () {
381 test_count=$(($test_count+1))
382 to_skip=
383 for skp in $GIT_SKIP_TESTS
385 case $this_test.$test_count in
386 $skp)
387 to_skip=t
388 esac
389 done
390 if test -z "$to_skip" && test -n "$prereq" &&
391 ! test_have_prereq "$prereq"
392 then
393 to_skip=t
395 case "$to_skip" in
397 say_color skip >&3 "skipping test: $@"
398 say_color skip "ok $test_count: # skip $1"
399 : true
402 false
404 esac
407 test_expect_failure () {
408 test "$#" = 3 && { prereq=$1; shift; } || prereq=
409 test "$#" = 2 ||
410 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
411 if ! test_skip "$@"
412 then
413 say >&3 "checking known breakage: $2"
414 test_run_ "$2"
415 if [ "$?" = 0 -a "$eval_ret" = 0 ]
416 then
417 test_known_broken_ok_ "$1"
418 else
419 test_known_broken_failure_ "$1"
422 echo >&3 ""
425 test_expect_success () {
426 test "$#" = 3 && { prereq=$1; shift; } || prereq=
427 test "$#" = 2 ||
428 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
429 if ! test_skip "$@"
430 then
431 say >&3 "expecting success: $2"
432 test_run_ "$2"
433 if [ "$?" = 0 -a "$eval_ret" = 0 ]
434 then
435 test_ok_ "$1"
436 else
437 test_failure_ "$@"
440 echo >&3 ""
443 test_expect_code () {
444 test "$#" = 4 && { prereq=$1; shift; } || prereq=
445 test "$#" = 3 ||
446 error "bug in the test script: not 3 or 4 parameters to test-expect-code"
447 if ! test_skip "$@"
448 then
449 say >&3 "expecting exit code $1: $3"
450 test_run_ "$3"
451 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
452 then
453 test_ok_ "$2"
454 else
455 test_failure_ "$@"
458 echo >&3 ""
461 # test_external runs external test scripts that provide continuous
462 # test output about their progress, and succeeds/fails on
463 # zero/non-zero exit code. It outputs the test output on stdout even
464 # in non-verbose mode, and announces the external script with "# run
465 # <n>: ..." before running it. When providing relative paths, keep in
466 # mind that all scripts run in "trash directory".
467 # Usage: test_external description command arguments...
468 # Example: test_external 'Perl API' perl ../path/to/test.pl
469 test_external () {
470 test "$#" = 4 && { prereq=$1; shift; } || prereq=
471 test "$#" = 3 ||
472 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
473 descr="$1"
474 shift
475 if ! test_skip "$descr" "$@"
476 then
477 # Announce the script to reduce confusion about the
478 # test output that follows.
479 say_color "" "# run $test_count: $descr ($*)"
480 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
481 # to be able to use them in script
482 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
483 # Run command; redirect its stderr to &4 as in
484 # test_run_, but keep its stdout on our stdout even in
485 # non-verbose mode.
486 "$@" 2>&4
487 if [ "$?" = 0 ]
488 then
489 if test $test_external_has_tap -eq 0; then
490 test_ok_ "$descr"
491 else
492 say_color "" "# test_external test $descr was ok"
493 test_success=$(($test_success + 1))
495 else
496 if test $test_external_has_tap -eq 0; then
497 test_failure_ "$descr" "$@"
498 else
499 say_color error "# test_external test $descr failed: $@"
500 test_failure=$(($test_failure + 1))
506 # Like test_external, but in addition tests that the command generated
507 # no output on stderr.
508 test_external_without_stderr () {
509 # The temporary file has no (and must have no) security
510 # implications.
511 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
512 stderr="$tmp/git-external-stderr.$$.tmp"
513 test_external "$@" 4> "$stderr"
514 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
515 descr="no stderr: $1"
516 shift
517 say >&3 "# expecting no stderr from previous command"
518 if [ ! -s "$stderr" ]; then
519 rm "$stderr"
521 if test $test_external_has_tap -eq 0; then
522 test_ok_ "$descr"
523 else
524 say_color "" "# test_external_without_stderr test $descr was ok"
525 test_success=$(($test_success + 1))
527 else
528 if [ "$verbose" = t ]; then
529 output=`echo; echo "# Stderr is:"; cat "$stderr"`
530 else
531 output=
533 # rm first in case test_failure exits.
534 rm "$stderr"
535 if test $test_external_has_tap -eq 0; then
536 test_failure_ "$descr" "$@" "$output"
537 else
538 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
539 test_failure=$(($test_failure + 1))
544 # This is not among top-level (test_expect_success | test_expect_failure)
545 # but is a prefix that can be used in the test script, like:
547 # test_expect_success 'complain and die' '
548 # do something &&
549 # do something else &&
550 # test_must_fail git checkout ../outerspace
553 # Writing this as "! git checkout ../outerspace" is wrong, because
554 # the failure could be due to a segv. We want a controlled failure.
556 test_must_fail () {
557 "$@"
558 test $? -gt 0 -a $? -le 129 -o $? -gt 192
561 # Similar to test_must_fail, but tolerates success, too. This is
562 # meant to be used in contexts like:
564 # test_expect_success 'some command works without configuration' '
565 # test_might_fail git config --unset all.configuration &&
566 # do something
569 # Writing "git config --unset all.configuration || :" would be wrong,
570 # because we want to notice if it fails due to segv.
572 test_might_fail () {
573 "$@"
574 test $? -ge 0 -a $? -le 129 -o $? -gt 192
577 # test_cmp is a helper function to compare actual and expected output.
578 # You can use it like:
580 # test_expect_success 'foo works' '
581 # echo expected >expected &&
582 # foo >actual &&
583 # test_cmp expected actual
586 # This could be written as either "cmp" or "diff -u", but:
587 # - cmp's output is not nearly as easy to read as diff -u
588 # - not all diff versions understand "-u"
590 test_cmp() {
591 $GIT_TEST_CMP "$@"
594 # This function can be used to schedule some commands to be run
595 # unconditionally at the end of the test to restore sanity:
597 # test_expect_success 'test core.capslock' '
598 # git config core.capslock true &&
599 # test_when_finished "git config --unset core.capslock" &&
600 # hello world
603 # That would be roughly equivalent to
605 # test_expect_success 'test core.capslock' '
606 # git config core.capslock true &&
607 # hello world
608 # git config --unset core.capslock
611 # except that the greeting and config --unset must both succeed for
612 # the test to pass.
614 test_when_finished () {
615 test_cleanup="{ $*
616 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
619 # Most tests can use the created repository, but some may need to create more.
620 # Usage: test_create_repo <directory>
621 test_create_repo () {
622 test "$#" = 1 ||
623 error "bug in the test script: not 1 parameter to test-create-repo"
624 owd=`pwd`
625 repo="$1"
626 mkdir -p "$repo"
627 cd "$repo" || error "Cannot setup test environment"
628 "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
629 error "cannot run git init -- have you built things yet?"
630 mv .git/hooks .git/hooks-disabled
631 cd "$owd"
634 test_done () {
635 GIT_EXIT_OK=t
636 test_results_dir="$TEST_DIRECTORY/test-results"
637 mkdir -p "$test_results_dir"
638 test_results_path="$test_results_dir/${0%.sh}-$$"
640 echo "total $test_count" >> $test_results_path
641 echo "success $test_success" >> $test_results_path
642 echo "fixed $test_fixed" >> $test_results_path
643 echo "broken $test_broken" >> $test_results_path
644 echo "failed $test_failure" >> $test_results_path
645 echo "" >> $test_results_path
647 if test "$test_fixed" != 0
648 then
649 say_color pass "# fixed $test_fixed known breakage(s)"
651 if test "$test_broken" != 0
652 then
653 say_color error "# still have $test_broken known breakage(s)"
654 msg="remaining $(($test_count-$test_broken)) test(s)"
655 else
656 msg="$test_count test(s)"
658 case "$test_failure" in
660 # Maybe print SKIP message
661 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
663 if test $test_external_has_tap -eq 0; then
664 say_color pass "# passed all $msg"
665 say "1..$test_count$skip_all"
668 test -d "$remove_trash" &&
669 cd "$(dirname "$remove_trash")" &&
670 rm -rf "$(basename "$remove_trash")"
672 exit 0 ;;
675 if test $test_external_has_tap -eq 0; then
676 say_color error "# failed $test_failure among $msg"
677 say "1..$test_count"
680 exit 1 ;;
682 esac
685 # Test the binaries we have just built. The tests are kept in
686 # t/ subdirectory and are run in 'trash directory' subdirectory.
687 TEST_DIRECTORY=$(pwd)
688 if test -n "$valgrind"
689 then
690 make_symlink () {
691 test -h "$2" &&
692 test "$1" = "$(readlink "$2")" || {
693 # be super paranoid
694 if mkdir "$2".lock
695 then
696 rm -f "$2" &&
697 ln -s "$1" "$2" &&
698 rm -r "$2".lock
699 else
700 while test -d "$2".lock
702 say "Waiting for lock on $2."
703 sleep 1
704 done
709 make_valgrind_symlink () {
710 # handle only executables
711 test -x "$1" || return
713 base=$(basename "$1")
714 symlink_target=$TEST_DIRECTORY/../$base
715 # do not override scripts
716 if test -x "$symlink_target" &&
717 test ! -d "$symlink_target" &&
718 test "#!" != "$(head -c 2 < "$symlink_target")"
719 then
720 symlink_target=../valgrind.sh
722 case "$base" in
723 *.sh|*.perl)
724 symlink_target=../unprocessed-script
725 esac
726 # create the link, or replace it if it is out of date
727 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
730 # override all git executables in TEST_DIRECTORY/..
731 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
732 mkdir -p "$GIT_VALGRIND"/bin
733 for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
735 make_valgrind_symlink $file
736 done
737 OLDIFS=$IFS
738 IFS=:
739 for path in $PATH
741 ls "$path"/git-* 2> /dev/null |
742 while read file
744 make_valgrind_symlink "$file"
745 done
746 done
747 IFS=$OLDIFS
748 PATH=$GIT_VALGRIND/bin:$PATH
749 GIT_EXEC_PATH=$GIT_VALGRIND/bin
750 export GIT_VALGRIND
751 elif test -n "$GIT_TEST_INSTALLED" ; then
752 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
753 error "Cannot run git from $GIT_TEST_INSTALLED."
754 PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
755 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
756 else # normal case, use ../bin-wrappers only unless $with_dashes:
757 git_bin_dir="$TEST_DIRECTORY/../bin-wrappers"
758 if ! test -x "$git_bin_dir/git" ; then
759 if test -z "$with_dashes" ; then
760 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
762 with_dashes=t
764 PATH="$git_bin_dir:$PATH"
765 GIT_EXEC_PATH=$TEST_DIRECTORY/..
766 if test -n "$with_dashes" ; then
767 PATH="$TEST_DIRECTORY/..:$PATH"
770 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
771 unset GIT_CONFIG
772 GIT_CONFIG_NOSYSTEM=1
773 GIT_CONFIG_NOGLOBAL=1
774 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
776 . ../GIT-BUILD-OPTIONS
778 DIFF="${DIFF:-diff}"
780 if test -z "$GIT_TEST_CMP"
781 then
782 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
783 then
784 GIT_TEST_CMP="$DIFF -c"
785 else
786 GIT_TEST_CMP="$DIFF -u"
790 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
791 export GITPERLLIB
792 test -d ../templates/blt || {
793 error "You haven't built things yet, have you?"
796 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
797 then
798 GITPYTHONLIB="$(pwd)/../git_remote_helpers/build/lib"
799 export GITPYTHONLIB
800 test -d ../git_remote_helpers/build || {
801 error "You haven't built git_remote_helpers yet, have you?"
805 if ! test -x ../test-chmtime; then
806 echo >&2 'You need to build test-chmtime:'
807 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
808 exit 1
811 # Test repository
812 test="trash directory.$(basename "$0" .sh)"
813 test -n "$root" && test="$root/$test"
814 case "$test" in
815 /*) TRASH_DIRECTORY="$test" ;;
816 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
817 esac
818 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
819 rm -fr "$test" || {
820 GIT_EXIT_OK=t
821 echo >&5 "FATAL: Cannot prepare test area"
822 exit 1
825 test_create_repo "$test"
826 # Use -P to resolve symlinks in our working directory so that the cwd
827 # in subprocesses like git equals our $PWD (for pathname comparisons).
828 cd -P "$test" || exit 1
830 this_test=${0##*/}
831 this_test=${this_test%%-*}
832 for skp in $GIT_SKIP_TESTS
834 to_skip=
835 for skp in $GIT_SKIP_TESTS
837 case "$this_test" in
838 $skp)
839 to_skip=t
840 esac
841 done
842 case "$to_skip" in
844 say_color skip >&3 "skipping test $this_test altogether"
845 say_color skip "skip all tests in $this_test"
846 test_done
847 esac
848 done
850 # Provide an implementation of the 'yes' utility
851 yes () {
852 if test $# = 0
853 then
855 else
856 y="$*"
859 while echo "$y"
862 done
865 # Fix some commands on Windows
866 case $(uname -s) in
867 *MINGW*)
868 # Windows has its own (incompatible) sort and find
869 sort () {
870 /usr/bin/sort "$@"
872 find () {
873 /usr/bin/find "$@"
875 sum () {
876 md5sum "$@"
878 # git sees Windows-style pwd
879 pwd () {
880 builtin pwd -W
882 # no POSIX permissions
883 # backslashes in pathspec are converted to '/'
884 # exec does not inherit the PID
885 test_set_prereq MINGW
888 test_set_prereq POSIXPERM
889 test_set_prereq BSLASHPSPEC
890 test_set_prereq EXECKEEPSPID
891 test_set_prereq NONMINGW
893 esac
895 test -z "$NO_PERL" && test_set_prereq PERL
896 test -z "$NO_PYTHON" && test_set_prereq PYTHON
898 # test whether the filesystem supports symbolic links
899 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
900 rm -f y